"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const utils_1 = require("./utils");
const html_minifier_terser_1 = require("html-minifier-terser");
const debug_1 = __importDefault(require("debug"));
const log = debug_1.default('vite:html');
const defaultMinifyOptions = {
    minifyCSS: true,
    minifyJS: true,
    minifyURLs: true,
    removeAttributeQuotes: true,
    trimCustomFragments: true,
    collapseWhitespace: true,
};
exports.default = (opt = {}) => {
    return {
        name: 'vite:html',
        transformIndexHtml: {
            enforce: 'pre',
            transform: (html) => {
                const { options = {} } = opt;
                let compiledHtml = html;
                try {
                    const compiled = lodash_1.template(compiledHtml);
                    compiledHtml = compiled({
                        viteHtmlPluginOptions: options,
                    });
                }
                catch (error) {
                    log('Template  compiled fail\n' + error);
                }
                const { title = '', minify = false, tags = [] } = opt;
                try {
                    let processCode = utils_1.injectTitle(compiledHtml, title);
                    if (!minify) {
                        return {
                            html: processCode,
                            tags,
                        };
                    }
                    if (lodash_1.isBoolean(minify)) {
                        return {
                            html: html_minifier_terser_1.minify(processCode, defaultMinifyOptions),
                            tags,
                        };
                    }
                    return {
                        html: html_minifier_terser_1.minify(processCode, {
                            ...defaultMinifyOptions,
                            ...minify,
                        }),
                        tags,
                    };
                }
                catch (error) {
                    log('Template transform fail\n' + error);
                    return { html: compiledHtml, tags };
                }
            },
        },
    };
};
__exportStar(require("./types"), exports);
